/**
 * Copyright (C) 2102 BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.runtime.event;

import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;

/**
 * 
 * @author Matthieu Chaffotte
 * 
 */
public abstract class JobExecutor extends EventExecutorThread {

  private int maxParallelJobs;

  private boolean cleanLocks;

  JobExecutor(final EventExecutor executor, final String name) {
    super(executor, name);
  }

  public abstract void notifyThreadFinished(ProcessInstanceUUID rootInstanceUUID);

  public abstract void cleanLocks();

  @Override
  protected final void activate() {
    if (cleanLocks) {
      cleanLocks();
    }
  }

  public void setMaxParallelJobs(final int maxParallelJobs) {
    this.maxParallelJobs = maxParallelJobs;
  }

  public int getMaxParallelJobs() {
    return maxParallelJobs;
  }

  public void setCleanLocks(final boolean cleanLocks) {
    this.cleanLocks = cleanLocks;
  }

}
